diff --git a/src/diff.c b/src/diff.c
index 5fa635f05df..e875d09b388 100644
--- a/src/diff.c
+++ b/src/diff.c
@@ -735,7 +735,7 @@ static int maybe_modified(
 	/* if we got here and decided that the files are modified, but we
 	 * haven't calculated the OID of the new item, then calculate it now
 	 */
-	if (status != GIT_DELTA_UNMODIFIED && git_oid_iszero(&nitem->oid)) {
+	if (status == GIT_DELTA_MODIFIED && git_oid_iszero(&nitem->oid)) {
 		if (git_oid_iszero(&noid)) {
 			if (git_diff__oid_for_file(diff->repo,
 					nitem->path, nitem->mode, nitem->file_size, &noid) < 0)
@@ -858,7 +858,7 @@ static int handle_unmatched_new_item(
 			git_buf_clear(&info->ignore_prefix);
 	}
 
-	if (S_ISDIR(nitem->mode)) {
+	if (nitem->mode == GIT_FILEMODE_TREE) {
 		bool recurse_into_dir = contains_oitem;
 
 		/* if not already inside an ignored dir, check if this is ignored */
@@ -962,6 +962,16 @@ static int handle_unmatched_new_item(
 	else if (info->new_iter->type != GIT_ITERATOR_TYPE_WORKDIR)
 		delta_type = GIT_DELTA_ADDED;
 
+	else if (nitem->mode == GIT_FILEMODE_COMMIT) {
+		git_submodule *sm;
+
+		/* ignore things that are not actual submodules */
+		if (git_submodule_lookup(&sm, info->repo, nitem->path) != 0) {
+			giterr_clear();
+			delta_type = GIT_DELTA_IGNORED;
+		}
+	}
+
 	/* Actually create the record for this item if necessary */
 	if ((error = diff_delta__from_one(diff, delta_type, nitem)) < 0)
 		return error;
diff --git a/tests-clar/diff/submodules.c b/tests-clar/diff/submodules.c
index fe9cf1d988f..94804db224c 100644
--- a/tests-clar/diff/submodules.c
+++ b/tests-clar/diff/submodules.c
@@ -5,36 +5,13 @@
 
 static git_repository *g_repo = NULL;
 
-static void setup_submodules(void)
-{
-	g_repo = cl_git_sandbox_init("submodules");
-	cl_fixture_sandbox("testrepo.git");
-	rewrite_gitmodules(git_repository_workdir(g_repo));
-	p_rename("submodules/testrepo/.gitted", "submodules/testrepo/.git");
-}
-
-static void setup_submodules2(void)
-{
-	g_repo = cl_git_sandbox_init("submod2");
-
-	cl_fixture_sandbox("submod2_target");
-	p_rename("submod2_target/.gitted", "submod2_target/.git");
-
-	rewrite_gitmodules(git_repository_workdir(g_repo));
-	p_rename("submod2/not-submodule/.gitted", "submod2/not-submodule/.git");
-	p_rename("submod2/not/.gitted", "submod2/not/.git");
-}
-
 void test_diff_submodules__initialize(void)
 {
 }
 
 void test_diff_submodules__cleanup(void)
 {
-	cl_git_sandbox_cleanup();
-
-	cl_fixture_cleanup("testrepo.git");
-	cl_fixture_cleanup("submod2_target");
+	cleanup_fixture_submodules();
 }
 
 static void check_diff_patches_at_line(
@@ -88,7 +65,7 @@ void test_diff_submodules__unmodified_submodule(void)
 		"<END>"
 	};
 
-	setup_submodules();
+	g_repo = setup_fixture_submodules();
 
 	opts.flags = GIT_DIFF_INCLUDE_IGNORED |
 		GIT_DIFF_INCLUDE_UNTRACKED |
@@ -115,7 +92,7 @@ void test_diff_submodules__dirty_submodule(void)
 		"<END>"
 	};
 
-	setup_submodules();
+	g_repo = setup_fixture_submodules();
 
 	cl_git_rewritefile("submodules/testrepo/README", "heyheyhey");
 	cl_git_mkfile("submodules/testrepo/all_new.txt", "never seen before");
@@ -141,7 +118,7 @@ void test_diff_submodules__dirty_submodule_2(void)
 		"<END>"
 	};
 
-	setup_submodules();
+	g_repo = setup_fixture_submodules();
 
 	cl_git_pass(git_submodule_reload_all(g_repo));
 
@@ -190,8 +167,6 @@ void test_diff_submodules__submod2_index_to_wd(void)
 	git_diff_list *diff = NULL;
 	static const char *expected[] = {
 		"<SKIP>", /* .gitmodules */
-		NULL, /* not-submodule */
-		NULL, /* not */
 		"diff --git a/sm_changed_file b/sm_changed_file\nindex 4800958..4800958 160000\n--- a/sm_changed_file\n+++ b/sm_changed_file\n@@ -1 +1 @@\n-Subproject commit 480095882d281ed676fe5b863569520e54a7d5c0\n+Subproject commit 480095882d281ed676fe5b863569520e54a7d5c0-dirty\n", /* sm_changed_file */
 		"diff --git a/sm_changed_head b/sm_changed_head\nindex 4800958..3d9386c 160000\n--- a/sm_changed_head\n+++ b/sm_changed_head\n@@ -1 +1 @@\n-Subproject commit 480095882d281ed676fe5b863569520e54a7d5c0\n+Subproject commit 3d9386c507f6b093471a3e324085657a3c2b4247\n", /* sm_changed_head */
 		"diff --git a/sm_changed_index b/sm_changed_index\nindex 4800958..4800958 160000\n--- a/sm_changed_index\n+++ b/sm_changed_index\n@@ -1 +1 @@\n-Subproject commit 480095882d281ed676fe5b863569520e54a7d5c0\n+Subproject commit 480095882d281ed676fe5b863569520e54a7d5c0-dirty\n", /* sm_changed_index */
@@ -200,7 +175,7 @@ void test_diff_submodules__submod2_index_to_wd(void)
 		"<END>"
 	};
 
-	setup_submodules2();
+	g_repo = setup_fixture_submod2();
 
 	opts.flags = GIT_DIFF_INCLUDE_UNTRACKED;
 	opts.old_prefix = "a"; opts.new_prefix = "b";
@@ -221,7 +196,7 @@ void test_diff_submodules__submod2_head_to_index(void)
 		"<END>"
 	};
 
-	setup_submodules2();
+	g_repo = setup_fixture_submod2();
 
 	cl_git_pass(git_repository_head_tree(&head, g_repo));
 
@@ -261,7 +236,7 @@ void test_diff_submodules__invalid_cache(void)
 		"<END>"
 	};
 
-	setup_submodules2();
+	g_repo = setup_fixture_submod2();
 
 	opts.flags = GIT_DIFF_INCLUDE_UNTRACKED;
 	opts.old_prefix = "a"; opts.new_prefix = "b";
@@ -390,8 +365,6 @@ void test_diff_submodules__diff_ignore_options(void)
 	git_config *cfg;
 	static const char *expected_normal[] = {
 		"<SKIP>", /* .gitmodules */
-		NULL, /* not-submodule */
-		NULL, /* not */
 		"diff --git a/sm_changed_file b/sm_changed_file\nindex 4800958..4800958 160000\n--- a/sm_changed_file\n+++ b/sm_changed_file\n@@ -1 +1 @@\n-Subproject commit 480095882d281ed676fe5b863569520e54a7d5c0\n+Subproject commit 480095882d281ed676fe5b863569520e54a7d5c0-dirty\n", /* sm_changed_file */
 		"diff --git a/sm_changed_head b/sm_changed_head\nindex 4800958..3d9386c 160000\n--- a/sm_changed_head\n+++ b/sm_changed_head\n@@ -1 +1 @@\n-Subproject commit 480095882d281ed676fe5b863569520e54a7d5c0\n+Subproject commit 3d9386c507f6b093471a3e324085657a3c2b4247\n", /* sm_changed_head */
 		"diff --git a/sm_changed_index b/sm_changed_index\nindex 4800958..4800958 160000\n--- a/sm_changed_index\n+++ b/sm_changed_index\n@@ -1 +1 @@\n-Subproject commit 480095882d281ed676fe5b863569520e54a7d5c0\n+Subproject commit 480095882d281ed676fe5b863569520e54a7d5c0-dirty\n", /* sm_changed_index */
@@ -401,20 +374,16 @@ void test_diff_submodules__diff_ignore_options(void)
 	};
 	static const char *expected_ignore_all[] = {
 		"<SKIP>", /* .gitmodules */
-		NULL, /* not-submodule */
-		NULL, /* not */
 		"<END>"
 	};
 	static const char *expected_ignore_dirty[] = {
 		"<SKIP>", /* .gitmodules */
-		NULL, /* not-submodule */
-		NULL, /* not */
 		"diff --git a/sm_changed_head b/sm_changed_head\nindex 4800958..3d9386c 160000\n--- a/sm_changed_head\n+++ b/sm_changed_head\n@@ -1 +1 @@\n-Subproject commit 480095882d281ed676fe5b863569520e54a7d5c0\n+Subproject commit 3d9386c507f6b093471a3e324085657a3c2b4247\n", /* sm_changed_head */
 		"diff --git a/sm_missing_commits b/sm_missing_commits\nindex 4800958..5e49635 160000\n--- a/sm_missing_commits\n+++ b/sm_missing_commits\n@@ -1 +1 @@\n-Subproject commit 480095882d281ed676fe5b863569520e54a7d5c0\n+Subproject commit 5e4963595a9774b90524d35a807169049de8ccad\n", /* sm_missing_commits */
 		"<END>"
 	};
 
-	setup_submodules2();
+	g_repo = setup_fixture_submod2();
 
 	opts.flags = GIT_DIFF_INCLUDE_UNTRACKED;
 	opts.old_prefix = "a"; opts.new_prefix = "b";
diff --git a/tests-clar/diff/workdir.c b/tests-clar/diff/workdir.c
index 6a2504d09b2..c7fac1e481b 100644
--- a/tests-clar/diff/workdir.c
+++ b/tests-clar/diff/workdir.c
@@ -776,6 +776,7 @@ void test_diff_workdir__submodules(void)
 
 	opts.flags =
 		GIT_DIFF_INCLUDE_UNTRACKED |
+		GIT_DIFF_INCLUDE_IGNORED |
 		GIT_DIFF_RECURSE_UNTRACKED_DIRS |
 		GIT_DIFF_INCLUDE_UNTRACKED_CONTENT;
 
@@ -806,7 +807,7 @@ void test_diff_workdir__submodules(void)
 	 * only significant difference is that those Added items will show up
 	 * as Untracked items in the pure libgit2 diff.
 	 *
-	 * Then add in the two extra untracked items "not" and "not-submodule"
+	 * Then add in the two extra ignored items "not" and "not-submodule"
 	 * to get the 12 files reported here.
 	 */
 
@@ -815,8 +816,8 @@ void test_diff_workdir__submodules(void)
 	cl_assert_equal_i(0, exp.file_status[GIT_DELTA_ADDED]);
 	cl_assert_equal_i(0, exp.file_status[GIT_DELTA_DELETED]);
 	cl_assert_equal_i(2, exp.file_status[GIT_DELTA_MODIFIED]);
-	cl_assert_equal_i(0, exp.file_status[GIT_DELTA_IGNORED]);
-	cl_assert_equal_i(10, exp.file_status[GIT_DELTA_UNTRACKED]);
+	cl_assert_equal_i(2, exp.file_status[GIT_DELTA_IGNORED]);
+	cl_assert_equal_i(8, exp.file_status[GIT_DELTA_UNTRACKED]);
 
 	/* the following numbers match "git diff 873585" exactly */
 
diff --git a/tests-clar/status/submodules.c b/tests-clar/status/submodules.c
index af870772147..7bfef503ff5 100644
--- a/tests-clar/status/submodules.c
+++ b/tests-clar/status/submodules.c
@@ -9,25 +9,19 @@ static git_repository *g_repo = NULL;
 
 void test_status_submodules__initialize(void)
 {
-	g_repo = cl_git_sandbox_init("submodules");
-
-	cl_fixture_sandbox("testrepo.git");
-
-	rewrite_gitmodules(git_repository_workdir(g_repo));
-
-	p_rename("submodules/testrepo/.gitted", "submodules/testrepo/.git");
 }
 
 void test_status_submodules__cleanup(void)
 {
-	cl_git_sandbox_cleanup();
-	cl_fixture_cleanup("testrepo.git");
+	cleanup_fixture_submodules();
 }
 
 void test_status_submodules__api(void)
 {
 	git_submodule *sm;
 
+	g_repo = setup_fixture_submodules();
+
 	cl_assert(git_submodule_lookup(NULL, g_repo, "nonexistent") == GIT_ENOTFOUND);
 
 	cl_assert(git_submodule_lookup(NULL, g_repo, "modified") == GIT_ENOTFOUND);
@@ -42,6 +36,8 @@ void test_status_submodules__0(void)
 {
 	int counts = 0;
 
+	g_repo = setup_fixture_submodules();
+
 	cl_assert(git_path_isdir("submodules/.git"));
 	cl_assert(git_path_isdir("submodules/testrepo/.git"));
 	cl_assert(git_path_isfile("submodules/.gitmodules"));
@@ -86,6 +82,8 @@ void test_status_submodules__1(void)
 {
 	status_entry_counts counts;
 
+	g_repo = setup_fixture_submodules();
+
 	cl_assert(git_path_isdir("submodules/.git"));
 	cl_assert(git_path_isdir("submodules/testrepo/.git"));
 	cl_assert(git_path_isfile("submodules/.gitmodules"));
@@ -104,6 +102,7 @@ void test_status_submodules__1(void)
 void test_status_submodules__single_file(void)
 {
 	unsigned int status = 0;
+	g_repo = setup_fixture_submodules();
 	cl_git_pass( git_status_file(&status, g_repo, "testrepo") );
 	cl_assert(!status);
 }
@@ -134,6 +133,8 @@ void test_status_submodules__moved_head(void)
 		GIT_STATUS_WT_NEW
 	};
 
+	g_repo = setup_fixture_submodules();
+
 	cl_git_pass(git_submodule_lookup(&sm, g_repo, "testrepo"));
 	cl_git_pass(git_submodule_open(&smrepo, sm));
 
@@ -192,6 +193,8 @@ void test_status_submodules__dirty_workdir_only(void)
 		GIT_STATUS_WT_NEW
 	};
 
+	g_repo = setup_fixture_submodules();
+
 	cl_git_rewritefile("submodules/testrepo/README", "heyheyhey");
 	cl_git_mkfile("submodules/testrepo/all_new.txt", "never seen before");
 
diff --git a/tests-clar/submodule/status.c b/tests-clar/submodule/status.c
index 68110bdd530..7b29ac28870 100644
--- a/tests-clar/submodule/status.c
+++ b/tests-clar/submodule/status.c
@@ -9,21 +9,12 @@ static git_repository *g_repo = NULL;
 
 void test_submodule_status__initialize(void)
 {
-	g_repo = cl_git_sandbox_init("submod2");
-
-	cl_fixture_sandbox("submod2_target");
-	p_rename("submod2_target/.gitted", "submod2_target/.git");
-
-	/* must create submod2_target before rewrite so prettify will work */
-	rewrite_gitmodules(git_repository_workdir(g_repo));
-	p_rename("submod2/not-submodule/.gitted", "submod2/not-submodule/.git");
-	p_rename("submod2/not/.gitted", "submod2/not/.git");
+	g_repo = setup_fixture_submod2();
 }
 
 void test_submodule_status__cleanup(void)
 {
-	cl_git_sandbox_cleanup();
-	cl_fixture_cleanup("submod2_target");
+	cleanup_fixture_submodules();
 }
 
 void test_submodule_status__unchanged(void)
@@ -326,6 +317,7 @@ void test_submodule_status__ignore_all(void)
 typedef struct {
 	size_t counter;
 	const char **paths;
+	int *statuses;
 } submodule_expectations;
 
 static int confirm_submodule_status(
@@ -336,6 +328,7 @@ static int confirm_submodule_status(
 	while (git__suffixcmp(exp->paths[exp->counter], "/") == 0)
 		exp->counter++;
 
+	cl_assert_equal_i(exp->statuses[exp->counter], (int)status_flags);
 	cl_assert_equal_s(exp->paths[exp->counter++], path);
 
 	GIT_UNUSED(status_flags);
@@ -365,7 +358,24 @@ void test_submodule_status__iterator(void)
 		"sm_unchanged",
 		NULL
 	};
-	submodule_expectations exp = { 0, expected };
+	static int expected_flags[] = {
+		GIT_STATUS_INDEX_MODIFIED | GIT_STATUS_WT_MODIFIED, /* ".gitmodules" */
+		0,					    /* "just_a_dir/" will be skipped */
+		GIT_STATUS_CURRENT,     /* "just_a_dir/contents" */
+		GIT_STATUS_CURRENT,	    /* "just_a_file" */
+		GIT_STATUS_IGNORED,	    /* "not" (contains .git) */
+		GIT_STATUS_IGNORED,     /* "not-submodule" (contains .git) */
+		GIT_STATUS_CURRENT,     /* "README.txt */
+		GIT_STATUS_INDEX_NEW,   /* "sm_added_and_uncommited" */
+		GIT_STATUS_WT_MODIFIED, /* "sm_changed_file" */
+		GIT_STATUS_WT_MODIFIED, /* "sm_changed_head" */
+		GIT_STATUS_WT_MODIFIED, /* "sm_changed_index" */
+		GIT_STATUS_WT_MODIFIED, /* "sm_changed_untracked_file" */
+		GIT_STATUS_WT_MODIFIED, /* "sm_missing_commits" */
+		GIT_STATUS_CURRENT,     /* "sm_unchanged" */
+		0
+	};
+	submodule_expectations exp = { 0, expected, expected_flags };
 	git_status_options opts = GIT_STATUS_OPTIONS_INIT;
 
 	cl_git_pass(git_iterator_for_workdir(&iter, g_repo,
@@ -378,6 +388,7 @@ void test_submodule_status__iterator(void)
 
 	opts.flags = GIT_STATUS_OPT_INCLUDE_UNTRACKED |
 		GIT_STATUS_OPT_INCLUDE_UNMODIFIED |
+		GIT_STATUS_OPT_INCLUDE_IGNORED |
 		GIT_STATUS_OPT_RECURSE_UNTRACKED_DIRS;
 
 	cl_git_pass(git_status_foreach_ext(
diff --git a/tests-clar/submodule/submodule_helpers.c b/tests-clar/submodule/submodule_helpers.c
index 0c3e79f717e..a7807522bac 100644
--- a/tests-clar/submodule/submodule_helpers.c
+++ b/tests-clar/submodule/submodule_helpers.c
@@ -82,3 +82,38 @@ void rewrite_gitmodules(const char *workdir)
 	git_buf_free(&out_f);
 	git_buf_free(&path);
 }
+
+git_repository *setup_fixture_submodules(void)
+{
+	git_repository *repo = cl_git_sandbox_init("submodules");
+
+	cl_fixture_sandbox("testrepo.git");
+
+	rewrite_gitmodules(git_repository_workdir(repo));
+	p_rename("submodules/testrepo/.gitted", "submodules/testrepo/.git");
+
+	return repo;
+}
+
+git_repository *setup_fixture_submod2(void)
+{
+	git_repository *repo = cl_git_sandbox_init("submod2");
+
+	cl_fixture_sandbox("submod2_target");
+	p_rename("submod2_target/.gitted", "submod2_target/.git");
+
+	rewrite_gitmodules(git_repository_workdir(repo));
+	p_rename("submod2/not-submodule/.gitted", "submod2/not-submodule/.git");
+	p_rename("submod2/not/.gitted", "submod2/not/.git");
+
+	return repo;
+}
+
+void cleanup_fixture_submodules(void)
+{
+	cl_git_sandbox_cleanup();
+
+	/* just try to clean up both possible extras */
+	cl_fixture_cleanup("testrepo.git");
+	cl_fixture_cleanup("submod2_target");
+}
diff --git a/tests-clar/submodule/submodule_helpers.h b/tests-clar/submodule/submodule_helpers.h
index 6b76a832e9a..1de15ca177e 100644
--- a/tests-clar/submodule/submodule_helpers.h
+++ b/tests-clar/submodule/submodule_helpers.h
@@ -1,2 +1,5 @@
 extern void rewrite_gitmodules(const char *workdir);
 
+extern git_repository *setup_fixture_submodules(void);
+extern git_repository *setup_fixture_submod2(void);
+extern void cleanup_fixture_submodules(void);
